import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;

/**This class does numerical experiments
for triples of polytope which are rectangle
bundles over the (x,P) plane*/

public class PolytopePrint {


    public static int[] special(int k) {
	int[][] a={{0,0,0,0,7},{0,0,0,2,9},{0,1,0,1,4},{0,1,0,0,5},{-1,0,0,14,19},{-1,0,0,15,18},{0,0,0,16,23},{-1,0,0,16,23},{-1,0,0,14,21}};
	return(a[k]);
    }


    public static void main() {
	for(int i=199;i<218;++i) {
	    int[][] x=DataTripleIndex.indexMinus(i);
	    int[] x1={x[0][0],x[0][1],x[0][2],x[0][3],x[1][3]};
	    int[] x2={x[0][0],x[0][1],x[0][2],x[1][3],x[0][3]};

	    for(int j=0;j<9;++j) {
		if(ListHelp.match(x1,special(j))==true) System.out.print(j+",");
		if(ListHelp.match(x2,special(j))==true) System.out.print(j+",");
	    }
	}
    }




    public static Polytope processPoly(int[] t,int k) {
	Polytope P1=AllPolytopes.graph(t[3]);
	Polytope P2=AllPolytopes.graph(t[4]);
	Polytope Q=new Polytope();
	Q.count=P1.count+P2.count;
	int count=0;
	for(int i=0;i<P1.count;++i) {
             Q.V[count]=new Vector4(P1.V[i]);
	     ++count;
	}
	for(int i=0;i<P2.count;++i) {
             Q.V[count]=new Vector4(P2.V[i]);
	     ++count;
	}
	Q=PolytopeRandom.cheapHull(Q);
	Q=GraphPolytopeMoves.shift(t[0],t[1],t[2],Q);
	if(k<4) Q=Polytope.shift(new Vector4(0,-1,0,0),Q);
	if(k>=4) Q=Polytope.shift(new Vector4(1,0,0,0),Q);
	return(Q);
    }





    public static void mainX() {
	Output OUT=new Output("temp");
	OUT.writeln("public class DataGraphDoubles {");
	OUT.writeln("public static int[][][] data() {");
	String S="int[][][] P={";

	for(int i=0;i<9;++i) {
	    Polytope P=processPoly(special(i),i);
	    S=S+cleanup(P);
	    if(i<8) S=S+",";
	}
	S=S+"};";
	OUT.writeln(S);
	OUT.writeln("return P;");
	OUT.writeln("}");
	OUT.writeln("");
	OUT.writeln("}");
    }







    /**This assumes that the denominator is 1,2,3,5*/

    public static String cleanup(double d) {
	double e=Math.floor(d+.5);
	int n=(int)(e);
	if(Math.abs(n-e)>.00001) System.out.println(1/0);
	Integer N=new Integer(n);
	return(N.toString());
    }

    public static String cleanup(Vector4 V) {
	String S="{";
	for(int i=0;i<4;++i) {
	    S=S+cleanup(V.x[i]);
	    if(i<3) S=S+",";
	}
	S=S+"}";
	return(S);
    }

    public static String cleanup(Polytope P) {
	String S="{";
	int n=P.count;
	for(int i=0;i<n;++i) {
	    S=S+cleanup(P.V[i]);
	    if(i<n-1) S=S+",";
	}
	S=S+"}";
	return(S);
    }



}


