public class DebugWeak implements Runnable{
    boolean HALT=true;


    public void run() {
	HALT=false;
	int p=1;
	int q=2;
	while(HALT==false) {
	    int[] P=MathRational.reduce(p,q);
	    int k=test(P[0],P[1]);
	    if(k==-1) { 
		throw new ProofException("weak copying fails");
	    }
	    ++p;
	    if(p==q) {
		p=1;
		++q;
	    }
	}
    }

    public  int test(int p,int q) {
	if((p*q)%2==1) return(0);
	int c=MathRational.classify(p,q);
	if(c!=0) return(0);
	System.out.println("weak copy test "+p+"/"+q);
	int[][] c1=table1(p,q);
	int[][] c2=table2(p,q);
	int h=c1.length-1;
	int w=c1[0].length-1;
	double aspect=1.0*h/w;
	double Q=2.0*p/(p+q);
	if(aspect<=Q) System.out.println("                "+p+"/"+q);
	return DebugCopySupport.match(c1,c2);
    }

    public  int[][] table1(int p,int q) {
	int[] A=MathRational.evenPredecessor(p,q);
	int t=MathRational.superTune(A[0],A[1]);
	int s=A[0]+A[1]-t;
	int[] a=DebugCopySupport.spectrumPQ(A[0],A[1],-2*t+1,s+2*t-1);
	int[] b=DebugCopySupport.spectrumH(A[0],A[1],t);
	return(DebugCopySupport.table(A[0],A[1],a,b));
    }


    public  int[][] table2(int p,int q) {
	int[] A=MathRational.evenPredecessor(p,q);
	int t=MathRational.superTune(A[0],A[1]);
	int s=A[0]+A[1]-t;
        int[] a=DebugCopySupport.spectrumPQ(p,q,-2*t+1,s+2*t-1);
	int[] b=DebugCopySupport.spectrumH(p,q,t);
	return(DebugCopySupport.table(a,b));
    }

}


