import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentIntro {

    public DocumentIntro() {}


    public static void setup(DocumentCanvas D) {
    
	String S="THE PLAID MODEL\n\n";
        S=S+"Richard Evan Schwartz\n";
	S=S+"program started: 11 August 2014\n";
	S=S+"Last updated:  2 Sept 2015\n";


	S=S+"\n\nPURPOSE:\n\n";
    S=S+"The purpose of this program is to allow the user to explore the plaid model, as it is presented in the first three papers I have written about it.\n\n--The first paper deals with the definition of the model and its higher dimensional compactification.\n\n--The second paper deals with the existence of unbounded orbits in the model.\n\n--The third paper deals with the quasi-isomorphism between the plaid model and the arithmetic graph for outer billiards on kites.\n\nI wrote an earlier program which just deals with the first of the three papers.  The program is considerably more elaborate, and also is biased towards the quasi-isomorphism theorem.  The quasi-isomorphism theorem is the deepest of the results I've gotten so far about the plaid model. In spite of the multi-purpose nature of this program, I have tried to organize it well and to make it coherent.";

	    S=S+"\n\nOPERATING INSTRUCTIONS\n\n";

	    S=S+"This window gives explanations for the rest of the program.  Drag the mouse over the text to scroll up or down. (There is more text than what is now visible.) The text in this window will change if you press some of the black ?-boxes. If you want to return this text, press the black ?-box at top left.";

	    S=S+"\n\nWhen this program opens, it shows two windows, this one and a control panel.  On the control panel, there is a console which allows you to bring up additional windows.  With several exceptions, the windows in this program have the following general features: \n\nkill: you can kill the various windows during the running of the program.\n\nresurrect: you can resurrect the windows by clicking on the appropriate button on the popup window console.\n\nresize: you can resize the window by dragging on the corner.\n\nscale:you can scale the window up or down by using the left and right mouse buttons. (This documentation window does not have this feature.\n\npoint selection: you can select a point on the window by clicking on the middle mouse button. (This docmentation window does not have this feature.)";

	    S=S+"\n\nThis program is designed to work best with a 3 button mouse. On the picture window, buttoms 1 and 3 zoom in and out of the picture and button 2 selects a new point. If you don't have a 3 button mouse, you can use the keyboard buttons z,x,c to simulate the 3 buttons when you are operating any of the windows where you might want to rescale the picture.";

	    S=S+"\n\nOVERVIEW OF THE WINDOWS:";

	    S=S+"\n\nplanar: This window displays both the plaid model and the arithmetic graph.";

	    S=S+"\n\ndocument: This is the window you are currently looking at.";

	    S=S+"\n\nhexagrid: This window controls the auxiliary grids which go into the definition of the plaid model. This window is not resizable or scalable, but you can select things on it.";

	    S=S+"\n\nPlaid PET:This window displays the 4-dimensional compactification of the plaid model.  I call this compactification the  Plaid PET.  Really this is a pair of windows.  One of the two windows is essentially a slicer, which lets you see various planar slices of the PET.  You can nagivate through the PET by dragging the mouse over the slicer window.";

	    S=S+"\n\nGraph PET:This window displays the 4-dimensional compactification of the arithmetic graph.  I call this compactification the Graph PET.  This is essentially the same PET that occues in my Master Picture Theorem from my book, Outer Billiards on Kites.  As with the Plaid PET, this window is really a pair of windows.";

	    S=S+"\n\nPET color control: This window allows you to change the coloring of the PETs. You might find this useful when you are drawing several different objects on top of one another.";

	    S=S+"\n\npartition control: This window allows you to manage the 218 polyhedral subsets of the Plaid and Graph PETs which are central to the proof of the quasi-isomorphism theorem.";

	    S=S+"\n\nparameter control: This window allows you to control how random parameters are generated.  All the objects in the program depend on a rational parameter p/q in (0,1) with pq even.  You can select these parameters at random.  The parameter control window lets you specify in advance the maximum denominator and related quantities.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }
}

