import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class DocumentPartition {

    public static void select(DocumentCanvas D) {

	String S="TRIPLE SELECT MODE\n\n";

	S=S+"First, we need a little background discussion on what this window controls. The plaid PET has a fine partition into 218 polytopes.  These polytopes control the length 3 strands in the plaid model.  This partition is obtained by intersecting the identity, forwards, and backwards plaid PET partitions. We call this partition the triple partition.  The triple partition can be drawn either in the plaid PET, where it is initially defined, or else in the graph PET.  In the graph PET, what we are drawing is the image under the plaid-to-graph correspondence map.";

	S=S+"\n\nThe left half of this window allows you to cycle through these 218 polytopes of the triple partition.  When considered in the graph PET, each of these polytopes is contained in one or graph PET polytopes from the (+) partition, and one or two from the (-) partition.  Here is the precise breakdown:\n\n180 of the triples are contained in unique (+) polytopes and unique (-) polytopes.\n\n19 are contained in unique (+) polytopes and in a union of two (-) polytopes.\n\n19 of the triples are contained in unique (-) polytopes and in a union of two (+) polytopes.\n\nHowever you select these triples, what is shown in the bottom left of this window is the pair of lattice vectors determined by the graph PET polytopes which contain the triple polytope.  This correspondence is the key to the quasi-isomorphism theorem: It explains how the local picture in the plaid model determines the local picture in the arithmetic graph.";

S=S+"\n\nThere are 3 ways to nagivate through these triples.";

S=S+"\n\n\nsingle:  In this mode, you use the arrow keys to navigate through the list.  The big blue arrow on the left cycles through the pieces one at a time. The big blue arrow on the right skips 10.  Using the two arrows together, you can navigate relatively quickly through the whole list.  As an exercise, try to select number 43.  You should see 3 dark blue tiles pointing left.";

S=S+"\n\n\nzone:  In this mode, you click on the arrowed squares in the upper left portion of the window.  You can change the triple to be whatever you like.  Once you have made a selection, some red boxes may (or may not) appear beneath what you have selected.  When you click on these boxes, you bring forth the triples on the list of 218 which have the given type.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }


    public static void edge(DocumentCanvas D) {

	String S="edge crossing problems:";
	S=S+"\n\nThis cluster of arrows and boxes controls the edge crossing problems. The big green arrows cycle through the 462 edge crossing problems.  The red arrows specifically pick out the 46 recalcitrant edge crossing problems.  Each crossing problem involves a triple polytope (i.e. a member of the triple partition) and an arithmetic graph edge type, and an edge of the unit square.  The problems are sorted according to the pair (arithmetic graph edge, square edge). There are 16 possibilities. If you click on a green box, you can jump to the problems involving any given pair.";

	S=S+"\n\nWhen you click on the green arrows, the bottom of the window will light up, showing the arithmetic graph edge involved and also the square edge.  At the same time, if you have the graph and plaid PET windows open, you will see the solution to the edge crossing problem.  A solution involves some demonstration that it is impossible for the graph edge to cross the square edge when it is associated to the triple involved in the problem. The solution either takes place in the plaid PET window or the graph PET window, depending on the problem. The 46 recalcitrant problems do not have solutions.";

	S=S+"\n\nOn the left hand side of the window, you can see some small numbered boxes associated to each plaid triple polytope. These numbered boxes indicate the forwards and backwards dynamics of the curve following map.  For all the recalcitrant problems, you will notice that there is a row of blue squares.  The blue squares indicate plaid triple polytopes which lie entirely outside the hitset.  What this means is that each recalcitrant edge crossing problem occurs in a unit integer square whose relevant neighbor is grid empty. This is the beginning of the proof that all such squares are involved in catches.  An inspection of the plaid arcs corresponding to these blue squares reveals the rest of the structure of the catch.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;


    }


    public static void graph(DocumentCanvas D) {

	String S="graph edge control:";

	S=S+"\n\nThis tic-toe-board lets you manage the display of the arithmetic graph edges.  Click on these squares and the corresponding arithmetic graph edge appears on the bottom of the window. A second click turns the display off. The easiest way to see this feature in action is to click on the green arrow keys below.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }



    public static void plaidgraph(DocumentCanvas D) {

	String S="plaid graph correspondence:";

	S=S+"\n\nThis control panel allows you to survey the plaid graph correspondence.  This is going to take a while to explain. First, the plaid triple partition is a refinement of the plaid partition which classifies the plaid model arcs of length 3.  You can survey the way the classification works by clicking on the blue arrow keys and seeing which triple corresponds to which numbers.  The numbers 0,1,2,3,4,5 have the empty label and the rest have nontrivial labels.  The first 6 polytopes are a partition of the place where the curve following dynamics on the plaid PET are trivial.";

	S=S+"\n\nSecond, there is a piecewise projective map from the plaid PET to the graph PET.  This map is called the projective intertwiner.  We take each plaid triple polytope and map it into the graph space using the projective intertwiner.  We see which graph polytopes intersect the image, and we read the labels of these graph polytopes.  For each of the two partitions, the (+) partition and the (-) partition, this gives us an assignment of arithmetic graph edges.  We display these edges at the bottom of the window.  Usually the assignment is unique, but for the last 38 triple polytopes, there are two edges for one of the partitions.  You can see this in action by clicking on the blue arrow keys.";

	S=S+"\n\nA word about the blue arrow keys:  The big keys advance the listing by 1.  The smaller keys advance the listing by 10.  This lets you nagivate more quickly through the listing.";

	S=S+"\n\nThe best way to see what the blue arrow keys do is to start the program over and hit the 'plaid-graph corr' preset.  Then the program will be set up in the best possible state for this feature.";

	S=S+"\n\nThe number of the plaid triple appears in the grey box. If you have the 'polytope info' window open, and you click on the grey box, you can see the vertices of the plaid triple and its image under the projective intertwiner.  We call this image the graph triple.";

	S=S+"\n\nThe row of little numbered boxes below the blue arrow keys indicates the curve following dynamics.  For instance, when you have selected plaid triple 6, the number 21 indicates that the backwards curve map carries plaid triple 6 into plaid triple 21.  The row 24,26,110,117 indicates that the forwards map carries plaid triple 6 into the union of plaid triples 24,26,110,117.  Sometimes these boxes are colored blue. These indicate plaid triples which lie outside the hitset.  The hitset is explained in my paper on the quasi-isomorphism theorem.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }

    public static void triple(DocumentCanvas D) {

	String S="triple manipulator:";

	S=S+"\n\nThis control panel lets you manually change the plaid triple you see. you should change the 'select' option to 'zone' before using it.  When you click on the arrowed squares, they change type, according the following scheme.  A left or right click cycles through the possibilities, and a middle click reverses the whole path.";

	S=S+"\n\nOnce you have made your selection (in zone mode) you will see a row of red squares beneath the numerical code of the triple you have selected.  These squares tell you which polytopes in the triple partition have the given type.  If you click on these red squares, you see the number.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }



    public static void square(DocumentCanvas D) {

	String S="square control:";

	S=S+"\n\nThe bottom portion of this window lets you manage the display of the 16 special sets.  Say that a crossing pair is a pair (E,F) where E is an arithmetic graph edge type and F is one of the sides of the unit square.  For each E there are two choices of F such that E could cross F if E is based in the unit square.  Let S(E,F) denote the set of positions of the point such that when E is based at this point it really does cross F.  The two choices of F thereby give a partition of the unit square into 2 pieces.";

S=S+"\n\nLet G be the graph grid.  Let G(E,F) denote the set of points in the graph grid which, when translated by integer shifts to the unit square, lie in S(E,F).  In other words, if the arithmetic graph edge of type E is based at a point of G(E,F), it crosses the F edge of the unit integer square containing that point.  You use the tic-tac-toe board at the top to select E and you use buttons below to select F.";

	S=S+"\n\nLet \u03D5 be the graph classifying map.  Once you select E and F, you can see the image of G(E,F) in the graph PET space under the map \u03D5.  You should have the graph PET windows open for this, and the slice should be set to Z. Also, it is useful to turn off the partition display on the graph PET control panel so that the display is uncluttered.";

	S=S+"\n\nThe center of this bottom portion of the control panel shows which edges you have selected.  The easiest way to see this part come to life is to click on the green arrows.";

        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;


    }



    public static void spider(DocumentCanvas D) {
	String S="SPIDER DISPLAY MODE\n\n";
	S=S+"This control panel allows you to display some special sets in the graph PET.  Let L be one of the 8 shortest lattice vectors in the arithmetic graph lattice.  For the sake of illustration, let's say that L corresponds to the pink square in the 3x3 grid. In this case, L points down and to the right.   If we think of L as being anchored at a lattice point v of the arithmetic graph lattice, then L can hit one of two edges of the unit square containing v:  L can either hit the South edge and the West edge.  Depending on the case, let's call the pair (v,L) South or West.";

	S=S+"\n\nThere are two natural sets in the graph PET, (S,L) and (W,L).  The region (S,L) has the property that a point (v,L) is South if and only if the classifing map carries v into (S,L).  The same goes for the other set.  All in all, there are 16=8x2 of these sets of interest to us.  The left half of this window controls the display of these sets.  The sets only depend on the X and Y coordinates.  So, you should have the Z slice on when using this feature.  There are 3 possible modes.";

    S=S+"\n\noff: Nothing is plotted.";

    S=S+"\n\nunrestricted: When L is selected the two sets (S,L) and (W,L) are plotted.  When other choices of L are made, the corresponding sets are plotted.";


    S=S+"\n\nrestricted: Here you select both a lattice vector and an edge.  So, if you select L and S, then the set (S,L) is plotted.";


        D.setExplain(S);
        D.repaint();   
	D.Y0=0;
        D.Y1=0;
    }








}


