import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;


public class GraphPETCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    Color[] COLOR=new Color[7];
    Point JX;

    public GraphPETCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(100,300,180);	
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g); 


      if(M.C.GRAPH.L[0].on==1) drawPartition(g,false);
      if(M.C.GRAPH.L[1].on==1) drawPartition(g,true);

      try{
          if(M.C.SANITY.L[4].on==1)  SpiderRender.drawSpiderCheck(M,this,g); //sanity plot
	  if(M.Z.SC.MODE.mode!=0)   SpiderRender.drawSpider(M,this,g);
      }
      catch(Exception e) {}


      if(M.C.GRAPH.L[2].on==1) drawTriples(g,false);
      if(M.C.GRAPH.L[3].on==1) drawTriples(g,true);
      if(M.C.GRAPH.L[4].on==1) drawDoubles(g);
      if(M.C.GRAPH.L[5].on==1) drawBarriers(g);
      if(M.C.GRAPH.L[6].on==1) drawFramework(g);
      drawImage(g);

   }

    /**This draws the current selected point
       in the PET*/

    public void drawImage(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(SOURCE.x,SOURCE.y);
	gp.lineTo(SOURCE.x,SOURCE.y);
	gp=transform(gp);
	g.setColor(Color.white);
	g.setStroke(new BasicStroke(5));
	g.fill(gp);
	g.draw(gp);
	g.setColor(Color.black);
	g.setStroke(new BasicStroke(2));
	g.fill(gp);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,0,0));
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawPartition(Graphics2D g,boolean select) {
	int c=M.GS.PARTITION.mode;
	int s=M.GS.DIRECTION.mode; 
        double t=M.GS.S[s];
	double A=M.GS.PAR;
	int lim1=0;
	int lim2=14;
	if(c==1) {
	    lim1=14;
	    lim2=28;
	}

	int cc=M.GS.TILE.val;
	for(int q1=-cc;q1<=cc;++q1) {
	    for(int q2=-cc;q2<=cc;++q2) {
		for(int q3=-cc;q3<=cc;++q3) {
		    for(int k=lim1;k<lim2;++k) {
			Polytope P=AllPolytopes.graph(k);
			P=GraphPolytopeMoves.shift(q1,q2,q3,P);
                        PolygonWrapper SP=P.slice(s,t,A);
	                if(SP!=null) { 
                            int t1=P.type[1];
            	            int t2=P.type[2];
			    Color C=GraphPETColors.COLOR[t1+1][t2+1];
			    int[] I={q1,q2,q3,k};
			    boolean test=false;
			    try{
			      test=match(c,M.Z.TS.getIndex(),I);
			    }
			    catch(Exception e) {}
			    if((select==false)||(test==true)) {
			      Path2D.Double gp=SP.toPath2D();
			      fillPoly(g,gp,C);
			      polyInfo(gp,q1,q2,q3,k);
			      polyInterpret(gp,q1,q2,q3,k);
			    }
			}
		    }
		}
	    }
	}
    }




    public boolean match(int partition,int choice,int[] I) {
	int[][] J={{0}};
	if(partition==0) J=DataTripleIndex.indexPlus(choice);
	if(partition==1) J=DataTripleIndex.indexMinus(choice);
	for(int i=0;i<J.length;++i) {
	    if(match(I,J[i])==true) return(true);
	}
	return(false);
    }


    public boolean match(int[] J,int[] K) {
	for(int i=0;i<4;++i) {
	    if(J[i]!=K[i]) return false;
	}
	return true;
    }

    public void drawPoly(Graphics2D g,Path2D.Double gp,Color C) {
       gp=transform(gp);
       g.setColor(C);
       g.draw(gp);
    }

    public void fillPoly(Graphics2D g,Path2D.Double gp,Color C) {
       gp=transform(gp);
       g.setColor(C);
       g.fill(gp);  
       g.setColor(Color.white);
       g.draw(gp);
    }

    /**This is for displaying the polytope vertices*/

    public void polyInfo(Path2D.Double gp,int q1,int q2,int q3,int k) {
	if(gp.contains(SOURCE.x,SOURCE.y)==true) {
	    try{   
		int p0=M.GS.PARTITION.mode;
		int[] ty=DataGraphPolytopes.type(k);
                int[] S={q1,q2,q3,p0,ty[0],ty[1]};
		int[] LIST={0};
		M.I.LIST=LIST;
		M.I.POLY[0]=k;
		M.I.DATA=S;
	    }
	    catch(Exception e) {}
	}
    }

    /**This communicates with the interpreter*/
    public void polyInterpret(Path2D.Double gp,int q1,int q2,int q3,int k) {
	if(gp.contains(SOURCE.x,SOURCE.y)==true) {
	    try{   
  	        int[] ty=DataGraphPolytopes.type(k);
		M.GI.type[0]=ty[0]+1;
		M.GI.type[1]=ty[1]+1;
	    }
	    catch(Exception e) {}
	}
    }


    /**draws the triple partition.*/

    public void drawTriples(Graphics2D g,boolean select) {
	int s=0;
	int dyn=0;
	double t=0;
	double A=0;
	try{
	  s=M.GS.DIRECTION.mode; 
          t=M.GS.getSlice();
	  A=M.GS.getParameter();
	}
	catch(Exception e) {}

	try{
	    dyn=M.QS.DYNAMICS.mode; //color choice
	}
	catch(Exception e) {}

	for(int i=0;i<218;++i) {
	    Polytope X=AllPolytopes.graphTriple(i);
	    boolean DRAWME=true;
	    try{
		if(select==true) DRAWME=M.Z.TS.matchesCode(X,i);
	    }
	    catch(Exception e) {}
	    if(DRAWME==true) {
            PolygonWrapper SPOLY=X.slice(s,t,A);
	    if(SPOLY!=null) {
	       Path2D.Double gp=SPOLY.toPath2D();
               int t1=0;
	       int t2=0;
	       if(dyn==0) {t1=X.code[2];t2=X.code[3];}
	       if(dyn==1) {t1=X.code[4];t2=X.code[5];}
	       if(dyn==2) {t1=X.code[0];t2=X.code[1];}

               Color C=PlaidPETColors.COLOR[t1][t2];
	       if(select==false) fillPoly(g,gp,C);

	       if(select==true) {
		   g.setStroke(new BasicStroke(3));
		   drawPoly(g,gp,Color.white);
		   g.setStroke(new BasicStroke(1));
	       }

	    }}
	}


    }

    public void drawDoubles(Graphics2D g) {
	int s=M.GS.DIRECTION.mode; 
        double t=M.GS.S[s];
	double A=M.GS.PAR;

	int index=0;
	try{index=M.Z.TS.getIndex();}
	catch(Exception e) {}

	int choice=DataGraphDoubles.whichContainer(index);
	if(choice==-1) return;
	Polytope P=AllPolytopes.graphDouble(choice);
        PolygonWrapper SP=P.slice(s,t,A);
	if(SP!=null) { 
	    Color C=new Color(255,255,0,150);
	    Path2D.Double gp=SP.toPath2D();
	    fillPoly(g,gp,C);
	    drawPoly(g,gp,new Color(255,255,0));
	}
    }



    public void drawBarriers(Graphics2D g) {
       	double A=0;
	int s=0;
	try{
            A=M.GS.getParameter();
            s=M.GS.DIRECTION.mode;
	}
	catch(Exception e) {return;}
	if(s!=2) return;
	int index=-1;
	try{index=M.Z.SC.AVOID.val;}
	catch(Exception e) {return;}

	int[] I=DataEdgeCrossing.index(index);
        long[][] W=ProofEdgeCrossing.getBarriers(I[2],I[3]);
        PolytopeLong[] P=ProofEdgeCrossing.getPolys(I);
	int test=-1;
	if(W==null) return;
        test=ProofEdgeCrossing.nonpositive(W,P);
	if(test==-1) return;

	Path2D.Double[] pd=Spider.makeBarrier(A,W);
	for(int i=0;i<pd.length;++i) {
	    pd[i]=transform(pd[i]);
	    g.setColor(new Color(255,255,0));
	    g.draw(pd[i]);
	}
    }

    public void drawFramework(Graphics2D g) {
	int s=0;
	double A=0;
	try{
	  s=M.GS.DIRECTION.mode; 
          A=M.GS.getParameter();
	}
	catch(Exception e) {}  
	if(s!=2) return;     
        g.setStroke(new BasicStroke(3));
	Path2D.Double gp=new Path2D.Double();

	for(int i=-2;i<3;++i) {
	    gp.reset();
	    gp.moveTo(i,-4);
	    gp.lineTo(i,4);
	    gp=transform(gp);
	    g.setColor(Color.yellow);
	    g.draw(gp);
	}

	for(int j=-2;j<=2;++j) {
	    gp.reset();
	    gp.moveTo(-2,-2*A+j*(1+A));
	    gp.lineTo(+2,+2*A+j*(1+A));
	    gp=transform(gp);
	    g.setColor(Color.yellow);
	    g.draw(gp);
	}
    }

    public void recognizePoint() {



    }



    public void mousePressed(MouseEvent e) { }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) { 
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	if(mode==2) {
	    SOURCE=unTransform(JX);
	    recognizePoint();
	}
	M.repaint();
    }

     public void mouseReleased(MouseEvent e) {	 
     }

    public void mouseEntered(MouseEvent e) {
	requestFocus();
    }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	JX=J.X;
     }

   
     public void mouseDragged(MouseEvent e) {
     }


    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
	int test=0;
	if(ch=='z') test=1;
	if(ch=='x') test=2;
	if(ch=='c') test=3;
	if(test>0) doMouseClick(test);
    }

 
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}


}

