import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ListHelp {

    /**This file does some routine things with lists*/

    public static int[] trim(int[] list1,int count) {
	int[] list2=new int[count];
	for(int i=0;i<count;++i) list2[i]=list1[i];
	return(list2);
    }

    public static int[][] trim(int[][] list1,int count) {
	int m=list1[0].length;
	int[][] list2=new int[count][m];
	for(int i=0;i<count;++i) list2[i]=list1[i];
	return(list2);
    }

    public static PolygonWrapper[] trim(PolygonWrapper[] list1,int count) {
	PolygonWrapper[] list2=new PolygonWrapper[count];
	for(int i=0;i<count;++i) list2[i]=new PolygonWrapper(list1[i]);
	return(list2);
    }


    public static Vector4Long[] trim(Vector4Long[] list1,int count) {
	Vector4Long[] list2=new Vector4Long[count];
	for(int i=0;i<count;++i) list2[i]=new Vector4Long(list1[i]);
	return(list2);
    }

    /**returns true iff either the vector or its negation is on the list.*/

    public static boolean onListWide(Vector4Long V,Vector4Long[] LIST,int count) {
	for(int i=0;i<count;++i) {
	    Vector4Long X1=Vector4Long.minus(V,LIST[i]);
	    Vector4Long X2=Vector4Long.plus(V,LIST[i]);
	    if(X1.isZero()==true) return true;
	    if(X2.isZero()==true) return true;
	}
	return false;
    }

    public static boolean match(int[] I,int [] J) {
	if(I.length!=J.length) return false;
	for(int i=0;i<I.length;++i) {
	    if(I[i]!=J[i]) return false;
	}
	return true;
    }

    public static boolean match(Vector4Long[] A,Vector4Long[] B) {
	if(A.length!=B.length) return false;
	int n=A.length;


	for(int i=0;i<n;++i) {
	    boolean test=false;
	    for(int j=0;j<n;++j) {
		if(match(A[i],B[j])==true) test=true;
	    }
	    if(test==false) return false;
	}


	for(int i=0;i<n;++i) {
	    boolean test=false;
	    for(int j=0;j<n;++j) {
		if(match(B[i],A[j])==true) test=true;
	    }
	    if(test==false) return false;
	}


	return true;
    }

    public static boolean match(Vector4Long A,Vector4Long B) {
	Vector4Long C=Vector4Long.minus(A,B);
	return C.isZero();
    }


    /**returns true iff either the vector is on the list*/

    public static boolean onListNarrow(Vector4Long[] V,Vector4Long[][] LIST,int count) {
	for(int i=0;i<count;++i) {
	    if(match(V,LIST[i])==true) return true;
	}
	return false;
    }

}