import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class Parameter {
    int x,y;
    String HISTORY;
    boolean ACTIVE;
    SelectInteger QI_TERM;
    ListenSquare MAIN,TEXT,INFO,QI,QI_CONVERT;
    ListenSquare SAVE,RECALL,PRED,CORE;
    ListenSquare[] RANDOM=new ListenSquare[5];
    Lever MODE;
    Color COLOR;
    String S,S_QI;
    int MEM_P,MEM_Q;

    public Parameter(int xx,int yy,String s) {
	this.x=xx;
	this.y=yy;
	this.S=s;
	TEXT=new ListenSquare(x,y,400,40);
	ACTIVE=false;
	COLOR=Color.blue;

	MODE=new Lever(x+65,y,0,3);
	MAIN=new ListenSquare(x,y,415,40);
	for(int i=0;i<3;++i) 
        RANDOM[i]=new ListenSquare(x+18*i,y+20,18,18);
	RANDOM[4]=new ListenSquare(x,y+20,46,18);
        QI=new ListenSquare(x,y+20,20,20);
        QI_CONVERT=new ListenSquare(x,y+40,50,20);
	QI_TERM=new SelectInteger(x+60,y+40,40,20,5,2,10,1);
	SAVE=new ListenSquare(x+80,y+20,50,18);
	RECALL=new ListenSquare(x+80,y+97,50,18);
	PRED=new ListenSquare(x+80,y+80,50,18);
	CORE=new ListenSquare(x+80,y+63,50,18);
	INFO=new ListenSquare(x+123,y,12,12);
	HISTORY="";
	MEM_P=1;
	MEM_Q=2;
    }

    public String toString(int a,int b) {
	Integer A=new Integer(a);
	Integer B=new Integer(b);
	String S=A.toString()+"/"+B.toString();
	return(S);
    }


    public void render(Graphics2D g) {
	if(MODE.val==0) renderSimple(g);
	if(MODE.val==1) renderAdvanced(g);
	if(MODE.val==2) renderQI(g);
    }

    public void renderSimple(Graphics2D g) {	
        drawBG(g,60);
	int p=getNumerator();
	int q=getDenominator();
	String TU="tune "+toString(MathRational.tune(p,q,1),p+q);

	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString(S,x+5,y+15);
	g.drawString(TU,x+5,y+53);

	MODE.render2(g,"",Color.red);
	RANDOM[4].render(g,new Color(0,0,150));
	g.setColor(Color.white);
	g.drawString("random",(int)(RANDOM[4].x+5),(int)(RANDOM[4].y+13));
	INFO.infoRender(g);
    }


    public void renderAdvanced(Graphics2D g) {	
        drawBG(g,115);
	int p=getNumerator();
	int q=getDenominator();
	String TU="tune "+toString(MathRational.tune(p,q,1),p+q);
	int[] A=MathRational.evenPredecessor(p,q);
	String PR="pred. "+toString(A[0],A[1]);
	A=MathRational.corePredecessor(p,q);
	String CO="core "+toString(A[0],A[1]);
	String ME="mem "+toString(MEM_P,MEM_Q);

	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString(S,x+5,y+15);
	g.drawString(TU,x+5,y+53);
	g.drawString(CO,x+5,y+76);
	g.drawString(PR,x+5,y+93);
	g.drawString(ME,x+5,y+110);


	MODE.render2(g,"",Color.red);
	CORE.render(g,new Color(200,0,100));
	PRED.render(g,new Color(200,0,200));
	for(int i=0;i<3;++i)
	    RANDOM[i].render(g,new Color(0,0,150));
	SAVE.render(g,new Color(0,150,0));
	RECALL.render(g,new Color(0,100,0));
	g.setColor(Color.white);
	g.drawString("recall",(int)(RECALL.x+5),(int)(RECALL.y+13));
	g.drawString("pred",(int)(PRED.x+5),(int)(PRED.y+13));
	g.drawString("core",(int)(CORE.x+5),(int)(CORE.y+13));
	g.drawString("save",(int)(SAVE.x+5),(int)(SAVE.y+13));
	INFO.infoRender(g);
    }


    public void renderQI(Graphics2D g) { 
        g.setFont(new Font("Helvetica",Font.PLAIN,12));	
        drawBG(g,60);
	g.drawString(S,x+5,y+15);
	MODE.render2(g,"",Color.red);
	INFO.infoRender(g);
	QI.render(g,new Color(180,0,200));
	QI_TERM.render(g,Color.red,Color.white,Color.white);
	QI_CONVERT.render(g,new Color(180,0,200));
	g.setColor(Color.white);
	g.drawString("qi",(int)(QI.x+5),(int)(QI.y+13));
	g.drawString("convert",(int)(QI_CONVERT.x+5),(int)(QI_CONVERT.y+13));
    }




    public void drawBG(Graphics2D g,int n) {
	g.setColor(Color.blue);
	g.fillRect(x,y,135,n);
	g.setColor(Color.white);
	g.drawRect(x,y,135,n);
    }

    public void activate(Point X) {
	ACTIVE=false;
	if(TEXT.inside(X)==1) ACTIVE=true;
    }


    /**This decides if we are looking at
       0. a rational
       1. a quadratic irrational
       2. a continued fraction expansion.
       This isn't a very smart routine; it just
       looks for one characteristic feature.
       The routine returns -1 if there is more
       than one characteristic.*/

    public int classify() {
	int c0=countChar(S,'*');
	int c1=countChar(S,':');
	int c2=countChar(S,'/');
	int c3=countChar(S,'(');
	int c4=countChar(S,')');
	if(c3!=c4) return(-1);
	if(c1>0) return(2);
	if(c3>0) return(1);
	if(c0>0) return(3);
	return(0);
    }

    public int[] interpretFraction() {
	return(interpretFraction(S));
    }

    public int[] interpretFraction(String U) {
	int k=U.indexOf("/");
	if(k==-1) {
	    U=U.replace(" ","");
	    Integer I=new Integer(U);
	    int[] a={I.intValue(),1};
	    return(a);
	}
	String T1=U.substring(0,k);
	String T2=U.substring(k+1,U.length());
	Integer I1=new Integer(T1);
	Integer I2=new Integer(T2);
	int[] I={I1.intValue(),I2.intValue()};
	return(I);
    }

    public int countChar(String T,char x) {
	int count=0;
	int n=T.length();
	for(int i=0;i<n;++i) {
	    char ch=T.charAt(i);
	    if(ch==x) ++count;
	}
	return(count);
    }

    public boolean acceptFraction(int[] b) {
	long[] c={b[0],b[1]};
	acceptFraction(c);
	return(true);
    }

    public boolean acceptFraction(long[] b) {
	if(b[0]<=0) return(false);
	if(b[1]<=0) return(false);
	Long b0=new Long(b[0]);
	Long b1=new Long(b[1]);
	S=b0.toString()+"/"+b1.toString();
	return(true);
    }

    public void reduce() {
	int[] x=interpretFraction();
        int s=MathRational.GCD(x[0],x[1]);
	x[0]=x[0]/s;
	x[1]=x[1]/s;
	acceptFraction(x);
    }

    /**quadratic irrationals*/
    public int[] interpretQI() {
	int k1=S.indexOf("+");
	int k2=S.indexOf("(");
	int k3=S.indexOf(")");
	String S1=S.substring(0,k1);
	String S2=S.substring(k1+1,k2);
	String S3=S.substring(k2+1,k3);

	S1=S1.replace(" ","");
	S2=S2.replace(" ","");
	S3=S3.replace(" ","");

	int[] a1=interpretFraction(S1);
	int[] a2=interpretFraction(S2);
	Integer b=new Integer(S3);
	int a3=b.intValue();
	int[] c={a1[0],a1[1],a2[0],a2[1],a3};
	return(c);
    }

    public int[] convertQItoFraction() {
       int[] a=interpretQI();
       double d=1.0*a[0]/a[1]+1.0*a[2]/a[3]*Math.sqrt(a[4]);
       d=d-Math.floor(d);
       double tol=Math.pow(.1,QI_TERM.val);
       MathRational P=MathApproximation.approximate0(d,tol);
       int[] p={(int)(P.p),(int)(P.q)};
       return(p);
    }

    public void doConvert() {
	try{
	  int[] a=convertQItoFraction(); 
	  if((a[0]*a[1])%2==0) {  
            S_QI=new String(S);
	    S=toString(a[0],a[1]);
	  }
	}
	catch(Exception e) {}
    }

    public void rememberQI() {
	S=new String(S_QI);
    }

    /**end quadratic irrational*/

    /**random selector*/

    public void doRandom(Point X) {
	if((MODE.val==0)&&(RANDOM[4].inside(X)==1)) {
	    getRandomSimple();
	    return;
	}
	int test=-1;
	for(int i=0;i<3;++i) {
	    if(RANDOM[i].inside(X)==1) test=i;
	}
	if(test!=-1) getRandom(test);
    }


    public int[] random() {
	boolean test=false;
	int[] a={};
	int max=32;
	int min=2;
	int diff=2;

	try{
           max=ParameterControl.B[0];
           min=ParameterControl.B[1];
           diff=ParameterControl.B[2];
	}
	catch(Exception e) {}

	while(test==false) {
	   int c=1+(int)(max*Math.random());
	   int b=1+(int)(Math.min(c,max*Math.random()));  
           a=MathRational.reduce(b,c);
           if((a[0]>=min)&&(a[1]-a[0]>=diff)&&(a[0]*a[1]%2==0)) test=true;
	}
	return(a);
    }

    public void getRandomSimple() {
	int[] a=random();
	Integer A0=new Integer(a[0]);
	Integer A1=new Integer(a[1]);
	S=A0.toString()+"/"+A1.toString();
	return;
    }

    public void getRandom(int i) {
	boolean test=false;
	int[] a={};
	while(test==false) {
	    a=random();
	    int c=MathRational.classify(a[0],a[1]);
	    int k=MathRational.coreNumber(a[0],a[1]);
	    if((c==0)&&(i==0)) test=true;
	    if((c==1)&&(i==1)) test=true;
	    if((c==2)&&(i==2)&&(k<4)) test=true;
	}
	Integer A0=new Integer(a[0]);
	Integer A1=new Integer(a[1]);
	S=A0.toString()+"/"+A1.toString();
	return;
    }




    public double getParameter() {
       int[] b=interpretFraction();
       double y=1.0*b[0]/b[1]; 
       return(y);
    }

    public int getNumerator() {
	int[] a=getFraction();
	return(a[0]);
    }

    public int getDenominator() {
	int[] a=getFraction();
	return(a[1]);
    }

    public int[] getFraction() {
	int[] a={1,2};
	try {
	   a=interpretFraction();
	}
	catch(Exception e) {}
	return(a);
    }



    /*testing whether the selector is used*/

    public boolean inside(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(MAIN.inside(J.X)==1) return(true);
	return(false);
    }

    public boolean inside(Point X) {
	if(MAIN.inside(X)==1) return(true);
	return(false);
    }

    public int plaidInside(MouseEvent e) {
	MouseData J=MouseData.process(e);
	return(0);
    }

    public void save() {
	MEM_P=getNumerator();
	MEM_Q=getDenominator();
    }

    public void recall() {
	S=toString(MEM_P,MEM_Q);
    }

    public int[] getPred() {
	int[] A=MathRational.evenPredecessor(getNumerator(),getDenominator());
	S=toString(A[0],A[1]);
	return(A);
    }

    public int[] getCore() {
	int[] A=MathRational.corePredecessor(getNumerator(),getDenominator());
	S=toString(A[0],A[1]);
	return(A);
    }


    public void process(MouseEvent e,Manager M) {
	MouseData J=MouseData.process(e);
	activate(J.X);
	if(MODE.val==0) processSimple(e,M);
	if(MODE.val==1) processAdvanced(e,M);
	if(MODE.val==2) processQI(e,M);
	MODE.process(J.X);
	if(INFO.inside(J.X)==1) DocumentControl.parameter(M.D);
    }

    public void processSimple(MouseEvent e,Manager M) {
	MouseData J=MouseData.process(e);
	doRandom(J.X);
	reduce();
    }

    public void processAdvanced(MouseEvent e,Manager M) {
	MouseData J=MouseData.process(e);
	doRandom(J.X);
	if(PRED.inside(J.X)==1) getPred();
	if(CORE.inside(J.X)==1) getCore();
	reduce();
	if(SAVE.inside(J.X)==1) save();
	if(RECALL.inside(J.X)==1) recall();
    }


    public void processQI(MouseEvent e,Manager M) {
	MouseData J=MouseData.process(e);
	QI_TERM.modify(J.X);
	if(QI.inside(J.X)==1) rememberQI();
	if(QI_CONVERT.inside(J.X)==1) doConvert();
    }


    public boolean processKey(KeyEvent e) {
	if(ACTIVE==false) return(false);
	int n=S.length();

	char ch=e.getKeyChar();

        if(isDigit(ch)==true) S=S+ch;

	int val=0;
	val=(int)(ch-'/');
	if(val==0) S=S+"/";

	val=(int)(ch-'(');
	if(val==0) S=S+"(";

	val=(int)(ch-':');
	if(val==0) S=S+":";

	val=(int)(ch-'*');
	if(val==0) S=S+"*";

	val=(int)(ch-')');
	if(val==0) S=S+")";

	val=(int)(ch-'+');
	if(val==0) S=S+"+";

	val=(int)(ch-'-');
	if(val==0) S=S+"-";

	val=(int)(ch-' ');
	if(val==0) S=S+" ";


        if (ch==KeyEvent.VK_BACK_SPACE) {
	    if(n>0) S=S.substring(0,n-1);
        }

        if (ch==KeyEvent.VK_DELETE) {
            S="1/2";
        }
	if(S.length()>50) S=S.substring(0,n-1);
	return(true);

    }

    public boolean isDigit(char ch) {
        int val=(int)(ch-'0');
        if ((val>=0)&&(val<=9)) {
	    return(true);
	}
	return(false);
    }


}





