import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;

/**This class does numerical experiments
for triples of polytope which are rectangle
bundles over the (x,P) plane*/

public class PolytopePrint {


    public static void main() {
	Output OUT=new Output("temp");
	OUT.writeln("public static int[][][] data() {");
	String S="int[][][] P={";

	for(int i=0;i<28;++i) {
	    Polytope P=AllPolytopes.graph(i);
	    if(i<14) P=Polytope.shift(new Vector4(0,-1,0,0),P);
	    if(i>13) P=Polytope.shift(new Vector4(1,0,0,0),P);
	    S=S+cleanup(P);
	    if(i<27) S=S+",";
	}
	S=S+"};";
	OUT.writeln(S);
	OUT.writeln("return P;");
	OUT.writeln("}");
	OUT.writeln("");
	OUT.writeln("}");
    }







    /**This assumes that the denominator is 1,2,3,5*/

    public static String cleanup(double d) {
	double e=Math.floor(d+.5);
	int n=(int)(e);
	if(Math.abs(n-e)>.00001) System.out.println(1/0);
	Integer N=new Integer(n);
	return(N.toString());
    }

    public static String cleanup(Vector4 V) {
	String S="{";
	for(int i=0;i<4;++i) {
	    S=S+cleanup(V.x[i]);
	    if(i<3) S=S+",";
	}
	S=S+"}";
	return(S);
    }

    public static String cleanup(Polytope P) {
	String S="{";
	int n=P.count;
	for(int i=0;i<n;++i) {
	    S=S+cleanup(P.V[i]);
	    if(i<n-1) S=S+",";
	}
	S=S+"}";
	return(S);
    }



}


