import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PopupManager {
    Manager M;
    int X,Y;
    ListenSquare INFO,PICTURE,PLAID,GRAPH,SPACETIME,CUBE,
	DOC,HEX,PART,COLOR,RAND,GRID,HITSET,TRUCHET;

    public PopupManager(Manager m,int x,int y) {
	M=m;
	this.X=x;
	this.Y=y;
	PICTURE=new ListenSquare(X,Y+30,70,40);
	PLAID=new ListenSquare(X+70,Y+30,70,40);
	GRAPH=new ListenSquare(X+70,Y+70,70,40);
	DOC=new ListenSquare(X,Y+110,70,40);
	HEX=new ListenSquare(X,Y+70,70,40);
	PART=new ListenSquare(X+70,Y+110,70,40);
	RAND=new ListenSquare(X+70,Y+190,70,40);
	INFO=new ListenSquare(X,Y+190,70,40);
	COLOR=new ListenSquare(X,Y+150,70,40);
	GRID=new ListenSquare(X+70,Y+150,70,40);
	SPACETIME=new ListenSquare(X+140,Y+30,70,40);
	CUBE=new ListenSquare(X+140,Y+70,70,40);
	TRUCHET=new ListenSquare(X+140,Y+110,70,40);

    }


    public void render(Graphics2D g) {
	g.setColor(Color.black);
	g.fillRect(X,Y,210,230);
	g.setColor(Color.white);
	g.drawRect(X,Y,210,230);
	PICTURE.render(g,new Color(200,0,0));
	PLAID.render(g,new Color(0,130,0));
	GRAPH.render(g,new Color(0,160,0));
	DOC.render(g,new Color(0,90,90));
	HEX.render(g,new Color(230,0,0));
	PART.render(g,new Color(0,190,0));
	RAND.render(g,new Color(0,0,255));
	COLOR.render(g,new Color(0,0,160));
	GRID.render(g,new Color(200,0,200));
	INFO.render(g,new Color(60,80,100));
	SPACETIME.render(g,new Color(60,0,100));
	CUBE.render(g,new Color(40,0,170));
	TRUCHET.render(g,new Color(180,0,130));

        g.setFont(new Font("Helvetica",Font.PLAIN,18));
	g.setColor(Color.white);
	g.drawString("popup windows",X+42,Y+22);

        g.setFont(new Font("Helvetica",Font.PLAIN,13));
	g.drawString("Planar",X+5,Y+55);
	g.drawString("Document",X+5,Y+135);
	g.drawString("hexagrid",X+5,Y+95);
	g.drawString("plaid PET",X+75,Y+55);
	g.drawString("graph PET",X+75,Y+95);
	g.drawString("partition",X+75,Y+125);
	g.drawString("control",X+75,Y+142);
	g.drawString("PET color",X+5,Y+165);
	g.drawString("control",X+5,Y+182);
	g.drawString("parameter",X+75,Y+205);
	g.drawString("control",X+75,Y+222);
	g.drawString("polytope",X+5,Y+205);
	g.drawString("into",X+5,Y+222);
	g.drawString("grid",X+75,Y+165);
	g.drawString("analyzer",X+75,Y+180);
	g.drawString("spacetime",X+145,Y+45);
	g.drawString("diagrams",X+145,Y+62);
	g.drawString("cube",X+145,Y+95);
	g.drawString("truchet",X+145,Y+135);
    }

    public void process(Point X) {

	if(PICTURE.inside(X)==1) {
	    PopupPictureCanvas PP=new PopupPictureCanvas();
	    PP.P.M=this.M;
	    M.P=PP.P;
	}

	if(DOC.inside(X)==1) {
	    PopupDocumentCanvas PD=new PopupDocumentCanvas();
	    PD.D.M=this.M;
	    M.D=PD.D;
	}

	if(HEX.inside(X)==1) {
	    PopupHexagridControl PH=new PopupHexagridControl();
	    PH.H.M=this.M;
	    M.H=PH.H;
	}

	if(PART.inside(X)==1) {
	    PopupPartitionControl PZ=new PopupPartitionControl();
	    PZ.Z.M=this.M;
	    M.Z=PZ.Z;
	}

	if(COLOR.inside(X)==1) {
	    PopupColorControl PB=new PopupColorControl();
	    PB.B.M=this.M;
	    M.B=PB.B;
	}

	if(GRID.inside(X)==1) {
	    PopupGridHitset PX=new PopupGridHitset();
	    PX.X.M=this.M;
	    M.X=PX.X;
	    PopupGridAnalyzer PY=new PopupGridAnalyzer();
	    PY.Y.M=this.M;
	    M.Y=PY.Y;
	}

	if(RAND.inside(X)==1) {
	    PopupParameterControl PR=new PopupParameterControl();
	    PR.R.M=this.M;
	    M.R=PR.R;
	}

	if(INFO.inside(X)==1) {
	    PopupPolytopeInfo PI=new PopupPolytopeInfo();
	    PI.I.M=this.M;
	    M.I=PI.I;
	}

	if(PLAID.inside(X)==1) {
	    PopupPlaidPETCanvas PQ=new PopupPlaidPETCanvas();
	    PQ.Q.M=this.M;
	    M.Q=PQ.Q;
	    PopupPlaidPETSlicer PQS=new PopupPlaidPETSlicer();
	    PQS.QS.M=this.M;
	    M.QS=PQS.QS;
	}

	if(GRAPH.inside(X)==1) {
	    PopupGraphPETCanvas PG=new PopupGraphPETCanvas();
	    PG.G.M=this.M;
	    M.G=PG.G;
	    PopupGraphPETSlicer PGS=new PopupGraphPETSlicer();
	    PGS.GS.M=this.M;
	    M.GS=PGS.GS;
	    PopupGraphPETInterpreter PGI=new PopupGraphPETInterpreter();
	    PGI.GI.M=this.M;
	    M.GI=PGI.GI;
	}

	if(SPACETIME.inside(X)==1) {
	    PopupSpacetime PST=new PopupSpacetime();
	    PST.ST.M=this.M;
	    M.ST=PST.ST;
	}

	if(CUBE.inside(X)==1) {
	    PopupCube PCU=new PopupCube();
	    PCU.CU.M=this.M;
	    M.CU=PCU.CU;
	}

	if(TRUCHET.inside(X)==1) {
	    PopupTruchet PTR=new PopupTruchet();
	    PTR.TR.M=this.M;
	    M.TR=PTR.TR;
	}
    }


}

