import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;

public class TripleSelector {
    ListenSquare[][] T=new ListenSquare[3][3];
    SelectInteger SELECT,SELECT10;
    int BACK,MID,FRONT;
    ControlPanel ZONE;
    boolean NULL;
    ListenSquare[] MEM=new ListenSquare[10];
    ListenSquare[] CON1=new ListenSquare[10];
    ListenSquare[] CON2=new ListenSquare[10];
    int COUNT,DIR,CHOICE,CHOICE1,CHOICE2;
    ListenSquare POLYINFO;
    ListenSquare[] INFO=new ListenSquare[3];
    int X;
    int Y;
    Manager M;

    public TripleSelector(Manager m,int x,int y) {
	M=m;
	X=x;
	Y=y;
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		T[i][j]=new ListenSquare(X+60*i,Y+120-60*j,60,60);
	    }
	}
	SELECT=new SelectInteger(X+5,Y+215,60,30,6,0,218,1);
	int[] init6={2,3,1,3,1,3};
	acceptCode(init6);
	SELECT10=new SelectInteger(X+15,Y+255,40,20,0,0,218,1);
	for(int i=0;i<10;++i) {
            MEM[i]=new ListenSquare(X+5+20*i,Y+205,20,20);
	    MEM[i].index=-1;
            CON1[i]=new ListenSquare(X+25*i,Y+290,25,20);
	    CON1[i].index=-1;
            CON2[i]=new ListenSquare(X+25*i,Y+310,25,20);
	    CON2[i].index=-1;
	}
	setPanel();
	POLYINFO=new ListenSquare(X+100,Y+235,70,40);
	INFO[0]=new ListenSquare(X,Y,12,12);
	INFO[1]=new ListenSquare(X,Y+180,12,12);
    }

    /**This returns the number of the current triple*/
    public int getIndex() {
	if(ZONE.mode==2) {
	    int k=-1;
	    if(DIR==1) k=CON1[CHOICE1].index;
	    if(DIR==2) k=CON2[CHOICE2].index;
	    if(k!=-1) return k;
	}
	if(ZONE.mode==1) return SELECT.val;
	if(MEM[CHOICE].index==-1) return SELECT.val;
	return MEM[CHOICE].index;
    }


    public void setPanel() {
         Color[] C0={new Color(0,0,255),
         Color.white,Color.white,Color.white,Color.red};
	 Color c=Color.white;
	 String[] ZoneString={
	     "zone","single","special","select"};
	 int[] ZoneState={0,1,0};
         ZONE=new ControlPanel(C0,ZoneString,ZoneState,3);
	 ZONE.mode=1;
    }

    public void makeChoice(Point X) {
	for(int i=0;i<10;++i) {
	    if((MEM[i].index!=-1)&&(MEM[i].inside(X)==1)) {
                  CHOICE=i;
	    } 
	}
    }

    public void getList() {
	int count=0;
	for(int i=0;i<10;++i) MEM[i].index=-1;
	for(int i=0;i<218;++i) {
	    Polytope P=AllPolytopes.graphTriple(i);
	    if(matchesCode(P)==true) {
		MEM[count].index=i;
		++count;
	    }
	}
    }

    public boolean matchesCode(Polytope P,int n) {
	if(ZONE.mode==1) {
	    if(n==SELECT.val) return true;
	    return false;
	}
	int c=MEM[CHOICE].index;
	if(n==c) return true;
	return false;
    }

    public boolean matchesCode(Polytope P) {
	int[] code=getCode();
	return match(P.code,code);
    }

    public void acceptCode(int[] J) {
	if((J[0]==0)&&(J[1]==0)) return;
	for(int b=0;b<3;++b) {
	    for(int m=0;m<12;++m) {
		for(int f=0;f<3;++f) {
		    int[] K=getCode(b,m,f);
		    if(match(J,K)==true) {
			BACK=b;
			FRONT=f;
			MID=m;
		    }
		}
	    }
	}
    }

    public boolean match(int[] J,int[] K) {
	for(int i=0;i<6;++i) {
	    if(J[i]!=K[i]) return false;
	}
	return true;
    }



    public int[] getCode() {
	return getCode(BACK,MID,FRONT);
    }

    public int[] getCode(int b,int m,int f) {
	int[] I2=convert(m);
	int back=partnerBack(I2[0],b);
	int front=partnerFront(I2[1],f);;
	int[] I1=convert(back);
	int[] I3=convert(front);
	int[] J={I1[0],I1[1],I2[0],I2[1],I3[0],I3[1]};
	return(J);
    }

    public void render(Graphics2D g) {
	drawFrame(g);
	drawControls(g);
	drawSelection(g);
	if((ZONE.mode!=1)||(SELECT.val>5)) {
	  render1(g);
	  render2(g); 
          drawCode(g);
  	  drawDynamics(g);
	  drawType(g);
	  for(int i=0;i<2;++i) INFO[i].infoRender(g);
	}
    }

    public void drawSelection(Graphics2D g) {
	int n=getIndex();
	Integer N=new Integer(n);
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,35));
	g.drawString(N.toString(),X+105,Y+268);
    }

    public void drawType(Graphics2D g) {
	int n=getIndex();
	Integer N=new Integer(n);
	Integer ord=new Integer(DataTripleIndex.ordering(n));
	int[][] plus=DataTripleIndex.typePlus(n);
	int[][] minus=DataTripleIndex.typeMinus(n);
	Path2D.Double gp=new Path2D.Double();
	g.setColor(Color.white);


	for(int i=-1;i<2;++i) {
	    for(int j=-1;j<2;++j) {
		gp=vector(i,j);
		g.setColor(new Color(80,80,80));
		g.draw(gp);
	    }
	}

	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,15));
	g.drawString(ord.toString(),5,350);
	g.setStroke(new BasicStroke(10));

	for(int i=0;i<plus.length;++i) {
	    Color C=GraphPETColors.COLOR[plus[i][0]+1][plus[i][1]+1];
	    g.setColor(C);
	    gp=vector(plus[i][0],plus[i][1]);
	    g.draw(gp);
	    Complex z=vectorEnd(plus[i][0],plus[i][1]);
	    g.setColor(Color.white);  
            g.setFont(new Font("Helvetica",Font.PLAIN,25));
	    g.drawString("+",(int)(X+90+80*z.x),(int)(Y+420+80*z.y));
	}
	for(int i=0;i<minus.length;++i) {
	    Color C=GraphPETColors.COLOR[minus[i][0]+1][minus[i][1]+1];
            g.setColor(C);
	    gp=vector(minus[i][0],minus[i][1]);
	    g.draw(gp); 
	    Complex z=vectorEnd(minus[i][0],minus[i][1]);
            g.setColor(Color.white);  
            g.setFont(new Font("Helvetica",Font.PLAIN,25));
	    g.drawString("_",(int)(X+90+80*z.x),(int)(Y+420+80*z.y));
	}

	g.setStroke(new BasicStroke(1));

    }




    public Path2D.Double vector(int a,int b) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(X+90,Y+420);
	Complex z=vectorEnd(a,b);
	gp.lineTo(X+90+80*z.x,Y+420+80*z.y);
	return(gp);
    }




    public Complex vectorEnd(int a,int b) {
	int k1=-3;
	int k2=1;
	double t1=2*k1*Math.PI/16;
	double t2=2*k2*Math.PI/16;
	double c1=Math.cos(t1);
	double s1=Math.sin(t1);
	double c2=Math.cos(t2);
	double s2=Math.sin(t2);
	double x=a*c1+b*c2;
	double y=a*s1+b*s2;
	double z=Math.sqrt(x*x+y*y);
	x=x/z;
	y=y/z;
	Complex zz=new Complex(x,y);
	return zz;
    }



    public void drawControls(Graphics2D g) {
	POLYINFO.render(g,new Color(60,80,100));
	ZONE.render(g,X+188,Y,66);
 	if(ZONE.mode==1) {
	    SELECT.render(g,Color.blue,Color.white,new Color(0,0,0,0));
          SELECT10.render(g,Color.blue,Color.white,new Color(0,0,0,0));
	}
	if(ZONE.mode!=0) return;
	for(int i=0;i<10;++i) {
	    Color C=Color.red;
	    if(i==CHOICE) C=Color.yellow;
	    if(MEM[i].index!=-1) MEM[i].render(g,C);
	}
    }




    public void drawCode(Graphics2D g) {
	String[] S={"S","W","N","E"};
	int[] J=getCode();
	int offset=20;
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,16));
	for(int i=0;i<6;++i) {
	    String SS=new String(S[J[i]]);
	    g.drawString(SS,X+offset,Y+200);
	    offset=offset+18;
	    if(i%2==1) offset=offset+18;
	}
    }

    public void drawFrame(Graphics2D g) {
	g.setColor(new Color(80,0,140));
	g.fillRect(X,Y,180,510);
	g.setColor(Color.white);
	g.drawRect(X,Y,180,510);
	g.setColor(new Color(0,0,0));
	g.fillRect(X,Y,180,180);
	g.setColor(Color.white);
	g.drawRect(X,Y,180,180);
	g.setColor(Color.black);
	g.fillRect(X,Y+330,180,180);
	g.setColor(Color.white);
	g.drawRect(X,Y+330,180,180);
    }

    public void drawDynamics(Graphics2D g) {
	if(ZONE.mode==0) return;
        g.setFont(new Font("Helvetica",Font.PLAIN,11));
	g.setColor(new Color(255,255,0));

	int[] list1=DataTripleDynamics.forward(SELECT.val);
	Arrays.sort(list1);
	for(int i=0;i<list1.length;++i) {
	    Color C=new Color(0,90,0);
	    if((DIR==1)&&(CHOICE1==i)) C=new Color(0,180,0);
            if(DataEdgeCrossing.isOutside(list1[i])==true) C=new Color(0,0,255);
	    CON1[i].render(g,C);
	}
	for(int i=0;i<list1.length;++i) {
	    Integer K=new Integer(list1[i]);
	    g.drawString(K.toString(),X+4+25*i,Y+305);
	}


	int[] list2=DataTripleDynamics.backward(SELECT.val);
	Arrays.sort(list2);
	for(int i=0;i<list2.length;++i) {
	    Color C=new Color(0,90,0);
	    if((DIR==2)&&(CHOICE2==i)) C=new Color(0,180,0);
            if(DataEdgeCrossing.isOutside(list2[i])==true) C=new Color(0,0,255);
	    CON2[i].render(g,C);
	}
	for(int i=0;i<list2.length;++i) {
	    Integer K=new Integer(list2[i]);
	    g.drawString(K.toString(),X+4+25*i,Y+325);
	}



    }


    public void render1(Graphics2D g) {
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) { 
		int[] I=convert(MID);
		if((i==1)&&(j==1)) render1(g,T[i][j],MID);
		boolean test=good(I[0],i-1,j-1);
		if(test==true) render1(g,T[i][j],partnerBack(I[0],BACK));
		test=good(I[1],i-1,j-1);
		if(test==true) render1(g,T[i][j],partnerFront(I[1],FRONT));
	    }
	}
    }

    public void render2(Graphics2D g) {
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) { 
		int[] I=convert(MID);
		if((i==1)&&(j==1)) render2(g,T[i][j],MID);
		boolean test=good(I[0],i-1,j-1);
		if(test==true) render2(g,T[i][j],partnerBack(I[0],BACK));
		test=good(I[1],i-1,j-1);
		if(test==true) render2(g,T[i][j],partnerFront(I[1],FRONT));
	    }
	}
    }

    public void advanceMID(Point X,int e) {
	if(T[1][1].inside(X)==1) MID=(MID+e+12)%12;
    }

    public void advanceBACK(Point X,int e) {
	int[] I=convert(MID);
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		boolean test=good(I[0],i-1,j-1);
		if(test==true) {
		    if(T[i][j].inside(X)==1) BACK=(BACK+e+3)%3;
		}
	    }
	}
    }

    public void advanceFRONT(Point X,int e) {
	int[] I=convert(MID);
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		boolean test=good(I[1],i-1,j-1);
		if(test==true) {
		    if(T[i][j].inside(X)==1) FRONT=(FRONT+e+3)%3;
		}
	    }
	}
    }



    public int[] convert(int k) {
	int[][] I={{0,1},{0,2},{0,3},{1,0},{1,2},{1,3},{2,0},{2,1},{2,3},{3,0},{3,1},{3,2}};
	return I[k];
    }


    public int convert(int i,int j) {
	for(int k=0;k<12;++k) {
	    int[] K=convert(k);
	    if((K[0]==i)&&(K[1]==j)) return(k);
	}
	return(-1);
    }

    public int partnerFront(int i,int j) {
	int[][] a={{6,7,8},{9,10,11},{0,1,2},{3,4,5}};
	return(a[i][j]);
    }

    public int partnerBack(int i,int j) {
	int[][] a={{1,4,11},{2,5,8},{3,6,9},{0,7,10}};
	return(a[i][j]);
    }

    public int getSpecial(int k) {
	int[] n={12,17,50,81,183,186,188,192,196,202,204,205,206,209};
	return(n[k]);
    }

    public int getSpecialIndex(int k) {
	for(int i=0;i<14;++i) {
	    if(k==getSpecial(i)) return(i);
	}
	return(-1);
    }
    public void grabSpecial(Point X) {
	if(ZONE.mode!=2) return;
	int k=SELECT.val;
	int[] list1=DataTripleDynamics.forward(k);
	int[] list2=DataTripleDynamics.backward(k);
	for(int i=0;i<10;++i) CON1[i].index=-1;
	for(int i=0;i<10;++i) CON2[i].index=-1;

	for(int i=0;i<list1.length;++i) {
              CON1[i].index=list1[i];
	      if(CON1[i].inside(X)==1) {
		  DIR=1;
                  CHOICE1=i;
	          int kk=list1[i];
	          int[] code=DataTripleCodes.data(kk);
	          acceptCode(code);
	      }
	}

	for(int i=0;i<list2.length;++i) {
              CON2[i].index=list2[i];
	      if(CON2[i].inside(X)==1) {
		  DIR=2;
                  CHOICE2=i;
	          int kk=list2[i];
	          int[] code=DataTripleCodes.data(kk);
	          acceptCode(code);
	      }
	}

    }



    public void grabTriple(Point X) {
	if(ZONE.mode==0) return;
	SELECT.modifyCyclic(X);
	int t=SELECT10.upOrDown(X);
	SELECT.val=(SELECT.val+10*t+218)%218;
	int t2=SELECT.isModified(X);
	int t3=SELECT10.isModified(X);

	if((t2==1)||(t3==1)) {
	    Polytope P=AllPolytopes.plaidTriple(SELECT.val);
	    acceptCode(P.code);
	}
    }

    public void render1(Graphics2D g,ListenSquare t,Integer k) {
	int[] I=convert(k);
	Color C=PlaidPETColors.COLOR[I[0]][I[1]];
	t.render(g,C);
    }

    public void render2(Graphics2D g,ListenSquare t,Integer k) {
	int[] I=convert(k);
	Complex[] z1=getGuidepoints(t,I[0]);
	Complex z2=getMidpoint(t,I[1]);
	Complex z3=getCenter(t);
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(z1[0].x,z1[0].y);
	gp.lineTo(z1[1].x,z1[1].y);
	gp.curveTo(z1[1].x,z1[1].y,z3.x,z3.y,z2.x,z2.y);
	gp.curveTo(z2.x,z2.y,z3.x,z3.y,z1[0].x,z1[0].y);
	gp.closePath();
	g.setColor(Color.white);
	g.fill(gp);
	g.draw(gp);
    }



    public Complex getCenter(ListenSquare t) {
	double x=t.x;
	double y=t.y;
	double h2=1.0*t.h/2;
	double w2=1.0*t.w/2;
	return new Complex(x+h2,y+w2);
    }


    public Complex getMidpoint(ListenSquare t,int k) {
	double x=t.x;
	double y=t.y;
	double h2=1.0*t.h/2;
	double w2=1.0*t.w/2;
	double h=t.h;
	double w=t.w;
	if(k==0) return new Complex(x+h2,y+w);
	if(k==1) return new Complex(x,y+w2);
	if(k==2) return new Complex(x+h2,y);
	if(k==3) return new Complex(x+h,y+w2);
	return(new Complex());
    }


    public Complex[] getGuidepoints(ListenSquare t,int k) {
	double x=t.x;
	double y=t.y;
	double h1=2.0*t.h/5;
	double h2=3.0*t.h/5;
	double w1=2.0*t.w/5;
	double w2=3.0*t.w/5;
	double h=t.h;
	double w=t.w;

	if(k==0) {
	    Complex[] Z={new Complex(x+h1,y+w),new Complex(x+h2,y+w)};
	    return(Z);
	}

	if(k==1) {
	    Complex[] Z={new Complex(x,y+w1),new Complex(x,y+w2)};
	    return(Z);
	}

	if(k==2) {
	    Complex[] Z={new Complex(x+h1,y),new Complex(x+h2,y)};
	    return(Z);
	}

	if(k==3) {
	    Complex[] Z={new Complex(x+h,y+w1),new Complex(x+h,y+w2)};
	    return(Z);
	}
	return null;
    }




    /**a and b are the type; i and j are the indices*/


    public static boolean good(int a,int b,int i,int j) {
	if(good(a,i,j)==true) return(true);
	if(good(b,i,j)==true) return(true);
	return(false);
    }

    public static boolean good(int a,int i,int j) {
	int test1=(i+j+10)%2;
	if(test1==0) return(false);
	int[][] good={{0,0,-1},{2,0,1},{1,-1,0},{3,1,0}};
	for(int k=0;k<4;++k) {
	    if((a==good[k][0])&&(i==good[k][1])&&(j==good[k][2])) return true;
	}
	return(false);
    }

    public void setZones(Point X) {
	int test=ZONE.switchMode(X);
	if(test!=-1) {
	    if(ZONE.mode==1) {
		int[] code=DataTripleCodes.data(SELECT.val);
		acceptCode(code);
	    }
	}
    }

    public void documentStuff(Point X) {
	try{
	  if(ZONE.L[20].inside(X)==1) DocumentPartition.select(M.D);
	  if(INFO[0].inside(X)==1) DocumentPartition.triple(M.D);
  	  if(INFO[1].inside(X)==1) DocumentPartition.plaidgraph(M.D);
	}
	catch(Exception e) {}
    }

    public void sendPoly(Point X) {
	if(POLYINFO.inside(X)==0) return;
	int t=getIndex();
	try{
	    int[] LIST={2,3};
	    M.I.LIST=LIST;
	    M.I.POLY[2]=t;
	    M.I.POLY[3]=t;
	    }
	  catch(Exception e) {}
    }

    public void process(MouseEvent e) {  
        MouseData J=MouseData.process(e);  
	setZones(J.X);
	grabTriple(J.X);
	grabSpecial(J.X);
	if(J.mode==1) {
            advanceMID(J.X,+1); 
            advanceBACK(J.X,+1); 
            advanceFRONT(J.X,+1);
	}

	if(J.mode==2) {
	    int[] L=getCode();
	    int[] K={L[5],L[4],L[3],L[2],L[1],L[0]};
	    acceptCode(K);
	}

	if(J.mode==3) {
            advanceMID(J.X,-1); 
            advanceBACK(J.X,-1); 
            advanceFRONT(J.X,-1);
	}

	getList();
	makeChoice(J.X);
	sendPoly(J.X);
	documentStuff(J.X);
    }




}


